<?php

declare(strict_types=1);

namespace Drupal\pdf_reducer\Hook;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Hook\Attribute\Hook;

/**
 *
 */
class PdfReducerHooks {

  #[Hook('field_widget_single_element_form_alter')]
  public function addPdfReducerConstraintValidationToWidget(&$element, FormStateInterface $form_state, array $context): void {
    /** @var \Drupal\Core\Field\FieldItemListInterface<\Drupal\Core\Field\FieldItemInterface> $items */
    $items = $context['items'];
    if (
      $items->getFieldDefinition()->getType() == 'file'
      && str_contains($items->getFieldDefinition()
        ->getSetting('file_extensions'), 'pdf')
    ) {
      $this->addPdfReducerConstraintValidation($element);
    }
  }

  public function addPdfReducerConstraintValidation(&$element): void {
    $element['#upload_validators']['PdfReducerConstraint'] = [];
  }

}
